package org.eclipse.wide.client.nav;

import org.eclipse.wide.services.test.TestService;
import org.eclipse.wide.services.test.TestServiceAsync;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.HorizontalSplitPanel;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.Tree;
import com.google.gwt.user.client.ui.TreeItem;
import com.google.gwt.user.client.ui.VerticalPanel;

public class NavEntryPoint implements EntryPoint {

	private TestServiceAsync testService = GWT.create(TestService.class);
	
	public void onModuleLoad() {
		// Vertical panes
		HorizontalSplitPanel horPanel = new HorizontalSplitPanel();
		horPanel.setSplitPosition("20%");
		RootPanel.get().add(horPanel);
		
		Tree tree = new Tree();
		TreeItem treeitem1 = new TreeItem();
		treeitem1.setText("Tree Item 1");
		tree.addItem(treeitem1);
		TreeItem treeitem2 = new TreeItem();
		treeitem2.setText("Tree Item 2");
		treeitem1.addItem(treeitem2);
		horPanel.setLeftWidget(tree);
		
		VerticalPanel cmdPanel = new VerticalPanel();
		horPanel.setRightWidget(cmdPanel);
		
		final Label label = new Label("W-IDE Test");
		cmdPanel.add(label);
		
		Hyperlink createProject = new Hyperlink("Create project", "createProject");
		cmdPanel.add(createProject);
		
		testService.getPlatformOS(new AsyncCallback<String>() {
			public void onSuccess(String result) {
				label.setText(label.getText() + " on " + result);
			}
			
			public void onFailure(Throwable caught) {
				label.setText(label.getText() + " service call failed: ");
			}
		});
	}

}
